From: Mathias Gibbens <mathias@calenhad.com>
Description: Fix atomic alignment for 32 bit architectures
Forwarded: https://github.com/juju/clock/issues/11
diff --git a/testclock/dilated.go b/testclock/dilated.go
index 4333b11..0b4d764 100644
--- a/testclock/dilated.go
+++ b/testclock/dilated.go
@@ -24,11 +24,14 @@ func NewDilatedWallClock(realSecondDuration time.Duration) AdvanceableClock {
 }
 
 type dilationClock struct {
+	// offsetAtomic is the current dilated offset to allow for time jumps/advances.
+	// Must be the first item in the struct to ensure proper 64-bit alignment as
+	// documented at https://pkg.go.dev/sync/atomic#pkg-note-BUG
+	offsetAtomic int64
+
 	epoch              time.Time
 	realSecondDuration time.Duration
 
-	// offsetAtomic is the current dilated offset to allow for time jumps/advances.
-	offsetAtomic int64
 	// offsetChanged is a channel that is closed when timers need to be signaled
 	// that there is a offset change coming.
 	offsetChanged chan any
